# require_relative 'game'
# require_relative 'die'
# require_relative 'game_turn'
require_relative 'treasure_trove'
require_relative 'playable'

module StudioGame
  class Player
    include Playable

    attr_accessor :name, :health

    def initialize(name, health=100)
      @name = name.capitalize
      @health = health
      @found_treasures = Hash.new(0)
    end

    def to_s
      "I'm #{@name} with health = #{@health}, points = #{points}, and score = #{score}."
    end

    # def blam
    #   @health -= 10
    #   puts "#{@name} gets blammed!"
    # end
    #
    # def w00t
    #   @health += 15
    #   puts "#{@name} gets w00ted!"
    # end

    def score
      @health + points
    end

    # def strong?
    #   @health > 100
    # end

    def status
      strong? ? "Strong" : "Wimpy"
    end

    def <=>(other)
      other.score <=> score
    end

    def found_treasure(treasure)
      @found_treasures[treasure.name] += treasure.points
      puts "#{@name} found a #{treasure.name} worth #{treasure.points} points."
      puts "#{@name}'s treasures: #{@found_treasures}"
    end

    def points
      @found_treasures.values.reduce(0, :+)
    end

    def self.from_csv(string)
      name, health = string.split(',')
      new(name, Integer(health))
      # Player.new(name, Integer(health))
    end

    def each_found_treasure
      @found_treasures.each do |name, points|
      next_treasure = Treasure.new(name, points)
      yield next_treasure
    end
  end
end

if __FILE__ == $0
  player = StudioGame::Player.new("moe")
  puts player.name
  puts player.health
  player.w00t
  puts player.health
  player.blam
  puts player.health
  puts player.score
  end
end
